<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::asc_remover&lt; T, compare &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1asc__remover.html">asc_remover</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classdlib_1_1asc__remover-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::asc_remover&lt; T, compare &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::asc_remover&lt; T, compare &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1asc__remover.png" usemap="#dlib::asc_5Fremover_3C_20T_2C_20compare_20_3E_map" alt=""/>
  <map id="dlib::asc_5Fremover_3C_20T_2C_20compare_20_3E_map" name="dlib::asc_5Fremover_3C_20T_2C_20compare_20_3E_map">
<area href="classdlib_1_1remover.html" alt="dlib::remover&lt; T &gt;" shape="rect" coords="0,0,201,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a1cdcf567148fe5d50a6d1b81c3c22828"><td class="memItemLeft" align="right" valign="top">typedef compare&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1asc__remover.html#a1cdcf567148fe5d50a6d1b81c3c22828">compare_type</a></td></tr>
<tr class="separator:a1cdcf567148fe5d50a6d1b81c3c22828"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top">typedef T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a717e9bdbd0335036d142080dbac7d66d">type</a></td></tr>
<tr class="separator:a717e9bdbd0335036d142080dbac7d66d inherit pub_types_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a58a9b1fc66e5cd1412332fdc27fe700b"><td class="memItemLeft" align="right" valign="top"><a id="a58a9b1fc66e5cd1412332fdc27fe700b"></a>
<a class="el" href="classdlib_1_1asc__remover.html">asc_remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classdlib_1_1asc__remover.html">asc_remover</a> &amp;)</td></tr>
<tr class="separator:a58a9b1fc66e5cd1412332fdc27fe700b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1remover.html">remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a58be6630e553c7f4d14dd4c4c2b4c859">operator=</a> (const <a class="el" href="classdlib_1_1remover.html">remover</a> &amp;)</td></tr>
<tr class="separator:a58be6630e553c7f4d14dd4c4c2b4c859 inherit pro_methods_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_methods_classdlib_1_1remover"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classdlib_1_1remover')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classdlib_1_1remover.html">dlib::remover&lt; T &gt;</a></td></tr>
<tr class="memitem:a80c7e7417e08a66ca361f646a12aaa03 inherit pub_methods_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#a80c7e7417e08a66ca361f646a12aaa03">remove_any</a> (T &amp;item)=0</td></tr>
<tr class="separator:a80c7e7417e08a66ca361f646a12aaa03 inherit pub_methods_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:affdce4c606ea006c496cd6e34f8f9e10 inherit pub_methods_classdlib_1_1remover"><td class="memItemLeft" align="right" valign="top">virtual unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1remover.html#affdce4c606ea006c496cd6e34f8f9e10">size</a> () const =0</td></tr>
<tr class="separator:affdce4c606ea006c496cd6e34f8f9e10 inherit pub_methods_classdlib_1_1remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a1cdcf567148fe5d50a6d1b81c3c22828"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1cdcf567148fe5d50a6d1b81c3c22828">&#9670;&nbsp;</a></span>compare_type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T, typename compare&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef compare <a class="el" href="classdlib_1_1asc__remover.html">dlib::asc_remover</a>&lt; T, compare &gt;::<a class="el" href="classdlib_1_1asc__remover.html#a1cdcf567148fe5d50a6d1b81c3c22828">compare_type</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON T
    T is swappable by a global swap() and                
    T must have a default constructor and
    T must be comparable by compare where compare is a functor compatible with std::less 

WHAT THIS OBJECT REPRESENTS
    This object represents the same thing as remover except
    that remove_any() will remove elements in ascending order
    according to the compare functor.  
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="remover_8h_source.html">remover.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
